<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="robots" content="noodp" />
        <title>Zero To Hero: Working With Multiple Kubeconfig Files - AB Engineering Blog</title><meta name="description" content="We show you how to manage and work with multiple `kubeconfig` files from the comfort of the Linux CLI."><meta property="og:title" content="Zero To Hero: Working With Multiple Kubeconfig Files" />
<meta property="og:description" content="We show you how to manage and work with multiple `kubeconfig` files from the comfort of the Linux CLI." />
<meta property="og:type" content="article" />
<meta property="og:url" content="https://blog.alphabravo.io/posts/2021/zero-to-hero-working-with-multiple-kubeconfig/" /><meta property="og:image" content="https://blog.alphabravo.io/assets/2021/12/multiple-kubeconfig-social.png" /><meta property="article:section" content="posts" />
<meta property="article:published_time" content="2021-12-08T13:00:00+00:00" />
<meta property="article:modified_time" content="2021-12-08T13:00:00+00:00" />

<meta name="twitter:card" content="summary_large_image"/>
<meta name="twitter:image" content="https://blog.alphabravo.io/assets/2021/12/multiple-kubeconfig-social.png"/>

<meta name="twitter:title" content="Zero To Hero: Working With Multiple Kubeconfig Files"/>
<meta name="twitter:description" content="We show you how to manage and work with multiple `kubeconfig` files from the comfort of the Linux CLI."/>
<meta name="application-name" content="AB Engineering Blog">
<meta name="apple-mobile-web-app-title" content="AB Engineering Blog"><link rel="shortcut icon" type="image/x-icon" href="/favicon.ico" />
        <link rel="icon" type="image/png" sizes="32x32" href="/favicon-32x32.png">
        <link rel="icon" type="image/png" sizes="16x16" href="/favicon-16x16.png"><link rel="apple-touch-icon" sizes="180x180" href="/apple-touch-icon.png"><link rel="manifest" href="/site.webmanifest"><link rel="canonical" href="https://blog.alphabravo.io/posts/2021/zero-to-hero-working-with-multiple-kubeconfig/" /><link rel="prev" href="https://blog.alphabravo.io/posts/2021/single-node-rke2-pt2/" /><link rel="next" href="https://blog.alphabravo.io/posts/2021/bulk-delete-clouflare-dns/" /><link rel="stylesheet" href="/css/page.min.css"><link rel="stylesheet" href="/css/home.min.css"><script type="application/ld+json">
    {
        "@context": "http://schema.org",
        "@type": "BlogPosting",
        "headline": "Zero To Hero: Working With Multiple Kubeconfig Files",
        "inLanguage": "en",
        "mainEntityOfPage": {
            "@type": "WebPage",
            "@id": "https:\/\/blog.alphabravo.io\/posts\/2021\/zero-to-hero-working-with-multiple-kubeconfig\/"
        },"image": ["https:\/\/blog.alphabravo.io\/assets\/2021\/12\/multiple-kubeconfig--social.png"],"genre": "posts","keywords": "kubernetes, kubeconfig, krew","wordcount":  1241 ,
        "url": "https:\/\/blog.alphabravo.io\/posts\/2021\/zero-to-hero-working-with-multiple-kubeconfig\/","datePublished": "2021-12-08T13:00:00+00:00","dateModified": "2021-12-08T13:00:00+00:00","publisher": {
            "@type": "Organization",
            "name": "AlphaBravo","logo": "https:\/\/blog.alphabravo.io\/assets\/alphabravo-logoonly-outline1.png"},"author": {
                "@type": "Person",
                "name": "Mike 'MJ' Johnson"
            },"description": "We show you how to manage and work with multiple `kubeconfig` files from the comfort of the Linux CLI."
    }
    </script></head><body data-header-desktop="auto" data-header-mobile="auto"><script>(window.localStorage && localStorage.getItem('theme') ? localStorage.getItem('theme') === 'dark' : ('' === 'auto' ? window.matchMedia('(prefers-color-scheme: dark)').matches : '' === 'dark')) && document.body.setAttribute('theme', 'dark');</script>

        <div id="mask"></div><div class="wrapper"><header class="desktop" id="header-desktop">
    <div class="header-wrapper">
        <div class="header-title">
            <a href="/" title="AB Engineering Blog"><img
        class="lazyload logo"
        src="/svg/loading.min.svg"
        data-src="/assets/alphabravo-logoonly-outline1.png"
        data-srcset="/assets/alphabravo-logoonly-outline1.png, /assets/alphabravo-logoonly-outline1.png 1.5x, /assets/alphabravo-logoonly-outline1.png 2x"
        data-sizes="auto"
        alt="/assets/alphabravo-logoonly-outline1.png"
        title="/assets/alphabravo-logoonly-outline1.png" /><span id="id-1" class="typeit"></span></a>
        </div>
        <div class="menu">
            <div class="menu-inner"><a class="menu-item" href="/" title="Blog Homepage"> Home </a><a class="menu-item" href="https://alphabravo.io" title="AlphaBravo Website" rel="noopener noreffer" target="_blank"> AB Website </a><a class="menu-item" href="/posts/"> Posts </a><a class="menu-item" href="https://github.com/AlphaBravoCompany" rel="noopener noreffer" target="_blank"><i class='fab fa-github fa-fw'></i>  </a><a class="menu-item" href="https://linkedin.com/company/alphabravogov/" rel="noopener noreffer" target="_blank"><i class='fab fa-linkedin fa-fw'></i>  </a><span class="menu-item delimiter"></span><span class="menu-item search" id="search-desktop">
                        <input type="text" placeholder="Search" id="search-input-desktop">
                        <a href="#" class="search-button search-toggle" id="search-toggle-desktop" title="Search">
                            <i class="fas fa-search fa-fw"></i>
                        </a>
                        <a href="#" class="search-button search-clear" id="search-clear-desktop" title="Clear">
                            <i class="fas fa-times-circle fa-fw"></i>
                        </a>
                        <span class="search-button search-loading" id="search-loading-desktop">
                            <i class="fas fa-spinner fa-fw fa-spin"></i>
                        </span>
                    </span><a class="menu-item" href="/index.xml" title="RSS"><i class="fas fa-rss fa-fw" title="RSS"></i> </a><a href="javascript:void(0);" class="menu-item theme-switch" title="Switch Theme">
                    <i class="fas fa-adjust fa-fw"></i>
                </a>
            </div>
        </div>
    </div>
</header><header class="mobile" id="header-mobile">
    <div class="header-container">
        <div class="header-wrapper">
            <div class="header-title">
                <a href="/" title="AB Engineering Blog"><img
        class="lazyload logo"
        src="/svg/loading.min.svg"
        data-src="/assets/alphabravo-logoonly-outline1.png"
        data-srcset="/assets/alphabravo-logoonly-outline1.png, /assets/alphabravo-logoonly-outline1.png 1.5x, /assets/alphabravo-logoonly-outline1.png 2x"
        data-sizes="auto"
        alt="/assets/alphabravo-logoonly-outline1.png"
        title="/assets/alphabravo-logoonly-outline1.png" /><span id="id-2" class="typeit"></span></a>
            </div>
            <div class="menu-toggle" id="menu-toggle-mobile">
                <span></span><span></span><span></span>
            </div>
        </div>
        <div class="menu" id="menu-mobile"><div class="search-wrapper">
                    <div class="search mobile" id="search-mobile">
                        <input type="text" placeholder="Search" id="search-input-mobile">
                        <a href="#" class="search-button search-toggle" id="search-toggle-mobile" title="Search">
                            <i class="fas fa-search fa-fw"></i>
                        </a>
                        <a href="#" class="search-button search-clear" id="search-clear-mobile" title="Clear">
                            <i class="fas fa-times-circle fa-fw"></i>
                        </a>
                        <span class="search-button search-loading" id="search-loading-mobile">
                            <i class="fas fa-spinner fa-fw fa-spin"></i>
                        </span>
                    </div>
                    <a href="#" class="search-cancel" id="search-cancel-mobile">
                        Cancel
                    </a>
                </div><a class="menu-item" href="/" title="Blog Homepage">Home</a><a class="menu-item" href="https://alphabravo.io" title="AlphaBravo Website" rel="noopener noreffer" target="_blank">AB Website</a><a class="menu-item" href="/posts/" title="">Posts</a><a class="menu-item" href="https://github.com/AlphaBravoCompany" title="" rel="noopener noreffer" target="_blank"><i class='fab fa-github fa-fw'></i></a><a class="menu-item" href="https://linkedin.com/company/alphabravogov/" title="" rel="noopener noreffer" target="_blank"><i class='fab fa-linkedin fa-fw'></i></a><div class="menu-item"><a href="/index.xml" title="RSS"><i class="fas fa-rss fa-fw" title="RSS"></i> </a>
                <span>&nbsp;|&nbsp;</span><a href="javascript:void(0);" class="theme-switch" title="Switch Theme">
                    <i class="fas fa-adjust fa-fw"></i>
                </a>
            </div></div>
    </div>
</header><div class="search-dropdown desktop">
    <div id="search-dropdown-desktop"></div>
</div>
<div class="search-dropdown mobile">
    <div id="search-dropdown-mobile"></div>
</div><main class="main">
                <div class="container"><div class="toc" id="toc-auto">
            <h2 class="toc-title">Contents</h2>
            <div class="toc-content" id="toc-content-auto"></div>
        </div><article class="page single" data-toc="disable"><div class="featured-image"><img
        class="lazyload"
        src="/svg/loading.min.svg"
        data-src="/assets/2021/12/multiple-kubeconfig-full.png"
        data-srcset="/assets/2021/12/multiple-kubeconfig-full.png, /assets/2021/12/multiple-kubeconfig-full.png 1.5x, /assets/2021/12/multiple-kubeconfig-full.png 2x"
        data-sizes="auto"
        alt="/assets/2021/12/multiple-kubeconfig-full.png"
        title="We show you how to manage and work with multiple `kubeconfig` files from the comfort of the Linux CLI." /></div><div class="single-card" data-image="true"><h2 class="single-title animated flipInX">Zero To Hero: Working With Multiple Kubeconfig Files</h2><div class="post-meta">
                <div class="post-meta-line"><span class="post-author"><a href="/" title="Author" rel=" author" class="author"><i class="fas fa-user-circle fa-fw"></i>Mike 'MJ' Johnson</a></span></div>
                <div class="post-meta-line"><span><i class="far fa-calendar-alt fa-fw"></i>&nbsp;<time datetime="2021-12-08">2021-12-08</time></span>&nbsp;<span><i class="fas fa-pencil-alt fa-fw"></i>&nbsp;1241 words</span>&nbsp;
                    <span><i class="far fa-clock fa-fw"></i>&nbsp;6 minutes</span>&nbsp;</div>
            </div>
            
            <hr><div class="details toc" id="toc-static"  data-kept="">
                    <div class="details-summary toc-title">
                        <span>Contents</span>
                        <span><i class="details-icon fas fa-angle-right"></i></span>
                    </div>
                    <div class="details-content toc-content" id="toc-content-static"><nav id="TableOfContents">
  <ul>
    <li><a href="#kubeconfig-file-management"><code>kubeconfig</code> File Management</a></li>
    <li><a href="#updating-the-fields-in-your-kubeconfig">Updating the fields in your <code>kubeconfig</code></a></li>
    <li><a href="#important-note">Important Note</a></li>
    <li><a href="#welcome-to-krew">Welcome to Krew</a></li>
    <li><a href="#install-kubectx-and-kubens-with-krew">Install <code>kubectx</code> and <code>kubens</code> with Krew</a></li>
    <li><a href="#install-fzf-optional">Install FZF (Optional)</a></li>
    <li><a href="#merging-kubeconfig-files">Merging <code>kubeconfig</code> files</a></li>
    <li><a href="#using-kubectx-and-kubens">Using <code>kubectx</code> and <code>kubens</code></a></li>
    <li><a href="#closing">Closing</a></li>
  </ul>
</nav></div>
                </div><div class="content" id="content"><p>Scaling beyond managing a single Kubernetes cluster from the CLI gets hard quickly.</p>
<p>Even after digging in on the <a href="https://kubernetes.io/docs/tasks/access-application-cluster/configure-access-multiple-clusters/" target="_blank" rel="noopener noreffer">official documentation</a>, we feel that the process is just too complex to use efficiently on a daily basis.</p>
<p>Luckily we have some tips and tools that should help you with that process.</p>
<h2 id="kubeconfig-file-management"><code>kubeconfig</code> File Management</h2>
<p>Let&rsquo;s start with managing our <code>kubeconfig</code> files. They need to be treated with care as they are literally the keys to your Kubernetes kingdom.</p>
<ul>
<li>Keep them SAFE! Store them in a secret vault or password manager. Lock them down with proper permissions on your systems. Don&rsquo;t share them publically (or even privately).</li>
<li>Update them to be meaningful. Usually the <code>kubeconfig</code> files are output using the name <code>default</code> for everything, which is fine for a single cluster but does not work when trying to manage multiple files/clusters.</li>
<li>Organize them on your system so they can be reused again and again. Some folks merge their Kubeconfigs and toss the originals. I think being able to regenerate that merged <code>kubeconfig</code> on-demand from the original sources is important.</li>
</ul>
<h2 id="updating-the-fields-in-your-kubeconfig">Updating the fields in your <code>kubeconfig</code></h2>
<p>The first thing we need to do is update the fields in each <code>kubeconfig</code> to be unique and meaningful.</p>
<p><strong>IMPORTANT</strong></p>
<ul>
<li>Make copies of these before modifying them. (<code>cp config config.orig</code>) If you accidentally change something you shouldn&rsquo;t have, the file will no longer work and you may lose access to that cluster until you generate a new file.</li>
<li>Pay close attention to the relationship of the fields. The <code>cluster</code> and <code>user</code> fields relate to other fields in the file and should remain an equal value.</li>
</ul>
<p>Here is an example of a <code>kubeconfig</code> with the often found <code>default</code> values:</p>
<pre tabindex="0"><code>apiVersion: v1
clusters:
- cluster:
    certificate-authority-data: fake-ca-file
    server: https://0.0.0.0:6443
  name: default
contexts:
- context:
    cluster: default
    user: default
  name: default
current-context: default
kind: Config
preferences: {}
users:
- name: default
  user:
    client-certificate-data: fake-cert-file
    client-key-data: fake-key-file

</code></pre><p>Below is an updated &lsquo;kubeconfig&rsquo; with unique and descriptive:</p>
<pre tabindex="0"><code>apiVersion: v1
clusters:
- cluster:
    certificate-authority-data: fake-ca-file
    server: https://0.0.0.0:6443
  name: prod-cluster
contexts:
- context:
    cluster: prod-cluster
    user: admin@prod-cluster
  name: prod-cluster
current-context: prod-cluster
kind: Config
preferences: {}
users:
- name: admin@prod-cluster
  user:
    client-certificate-data: fake-cert-file
    client-key-data: fake-key-file
</code></pre><p>Once the cleanup is complete on all files and they are given meaningful names (prod-cluster, dev-cluster, etc), move them into the <code>~/.kube/</code> directory on your system.</p>
<h2 id="important-note">Important Note</h2>
<div class="details admonition note open">
        <div class="details-summary admonition-title">
            <i class="icon fas fa-pencil-alt fa-fw"></i>Linux and BASH Specific<i class="details-icon fas fa-angle-right fa-fw"></i>
        </div>
        <div class="details-content">
            <div class="admonition-content">The following instructions were tested on a Linux host (Ubuntu 20.04) and using the BASH shell. Pay close attention as your steps and requirements for implementing this may change based on if you are using another Linux distribution, MacOS, or Windows or are using another shell like ZSH or FISH.</div>
        </div>
    </div>
<h2 id="welcome-to-krew">Welcome to Krew</h2>
<p>Now that you have your <code>kubeconfig</code> files all in order, let&rsquo;s leverage some of the excellent <code>kubectl</code> tools that are out there.</p>
<p>Kubernetes <a href="https://github.com/kubernetes-sigs/krew/" target="_blank" rel="noopener noreffer">Krew</a> &ldquo;is the package manager for kubectl plugins.&rdquo;</p>
<p>You can get started by <a href="https://krew.sigs.k8s.io/docs/user-guide/setup/install/" target="_blank" rel="noopener noreffer">installing Krew here</a>. Krew supports Windows, Mac and other Linux distributons and instructions for each system are in that link.</p>
<p>I typically install it by running their included script on my system:</p>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-bash" data-lang="bash"><span class="o">(</span>
  <span class="nb">set</span> -x<span class="p">;</span> <span class="nb">cd</span> <span class="s2">&#34;</span><span class="k">$(</span>mktemp -d<span class="k">)</span><span class="s2">&#34;</span> <span class="o">&amp;&amp;</span>
  <span class="nv">OS</span><span class="o">=</span><span class="s2">&#34;</span><span class="k">$(</span>uname <span class="p">|</span> tr <span class="s1">&#39;[:upper:]&#39;</span> <span class="s1">&#39;[:lower:]&#39;</span><span class="k">)</span><span class="s2">&#34;</span> <span class="o">&amp;&amp;</span>
  <span class="nv">ARCH</span><span class="o">=</span><span class="s2">&#34;</span><span class="k">$(</span>uname -m <span class="p">|</span> sed -e <span class="s1">&#39;s/x86_64/amd64/&#39;</span> -e <span class="s1">&#39;s/\(arm\)\(64\)\?.*/\1\2/&#39;</span> -e <span class="s1">&#39;s/aarch64$/arm64/&#39;</span><span class="k">)</span><span class="s2">&#34;</span> <span class="o">&amp;&amp;</span>
  <span class="nv">KREW</span><span class="o">=</span><span class="s2">&#34;krew-</span><span class="si">${</span><span class="nv">OS</span><span class="si">}</span><span class="s2">_</span><span class="si">${</span><span class="nv">ARCH</span><span class="si">}</span><span class="s2">&#34;</span> <span class="o">&amp;&amp;</span>
  curl -fsSLO <span class="s2">&#34;https://github.com/kubernetes-sigs/krew/releases/latest/download/</span><span class="si">${</span><span class="nv">KREW</span><span class="si">}</span><span class="s2">.tar.gz&#34;</span> <span class="o">&amp;&amp;</span>
  tar zxvf <span class="s2">&#34;</span><span class="si">${</span><span class="nv">KREW</span><span class="si">}</span><span class="s2">.tar.gz&#34;</span> <span class="o">&amp;&amp;</span>
  ./<span class="s2">&#34;</span><span class="si">${</span><span class="nv">KREW</span><span class="si">}</span><span class="s2">&#34;</span> install krew
<span class="o">)</span>
</code></pre></div><p>If you are using BASH, add the path export to the <code>~/.bashrc</code> file. You may need to check <a href="https://krew.sigs.k8s.io/docs/user-guide/setup/install/" target="_blank" rel="noopener noreffer">here</a> on what to do if you are using FSH, ZSH or another shell.</p>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-bash" data-lang="bash"><span class="nb">export</span> <span class="nv">PATH</span><span class="o">=</span><span class="s2">&#34;</span><span class="si">${</span><span class="nv">KREW_ROOT</span><span class="k">:-</span><span class="nv">$HOME</span><span class="p">/.krew</span><span class="si">}</span><span class="s2">/bin:</span><span class="nv">$PATH</span><span class="s2">&#34;</span>
</code></pre></div><p>Reload your shell with the new <code>~/.bashrc</code> settings.</p>
<pre tabindex="0"><code>source ~/.bash_profile
source ~/.bashrc
</code></pre><p>Check to make sure Krew is installed and you can see the version:</p>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-bash" data-lang="bash">kubectl krew version
</code></pre></div><p>Output:</p>
<pre tabindex="0"><code>OPTION            VALUE
GitTag            v0.4.2
GitCommit         6fcdb79
IndexURI          https://github.com/kubernetes-sigs/krew-index.git
BasePath          /root/.krew
IndexPath         /root/.krew/index/default
InstallPath       /root/.krew/store
BinPath           /root/.krew/bin
DetectedPlatform  linux/amd64

</code></pre><p>Now that we have Krew installed, we can install the specific plugins we are interested in for this excercise.</p>
<h2 id="install-kubectx-and-kubens-with-krew">Install <code>kubectx</code> and <code>kubens</code> with Krew</h2>
<p>The 2 plugins that we will use are <a href="https://github.com/ahmetb/kubectx" target="_blank" rel="noopener noreffer"><code>kubectx</code> and <code>kubens</code></a>. They can be installed standalone, but I prefer to use them as part of Krew.</p>
<ul>
<li><code>kubectx</code>: A tool to switch between contexts (clusters) on kubectl faster.</li>
<li><code>kubens</code> : A tool to switch between Kubernetes namespaces (and configure them for kubectl) easily.</li>
</ul>
<p>You can follow the <a href="https://github.com/ahmetb/kubectx#kubectl-plugins-macos-and-linux" target="_blank" rel="noopener noreffer">install instructions here</a>.</p>
<p>Run the following commands to install with KREW.</p>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-bash" data-lang="bash">kubectl krew install ctx
kubectl krew install ns
</code></pre></div><p>Krew also has numerous other useful plugins. To view them all run:</p>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-bash" data-lang="bash">kubectl krew search
</code></pre></div><h2 id="install-fzf-optional">Install FZF (Optional)</h2>
<p>FZF is not a necessary plugin, but it is recommended by <code>kubens</code> and <code>kubectx</code> to make selections a bit more intuitive.</p>
<p>Recommendation for FZF by the <code>kubectx</code> and <code>kubens</code> dev <a href="https://github.com/ahmetb/kubectx#interactive-mode" target="_blank" rel="noopener noreffer">here</a>.</p>
<p>Install instructions for FZF <a href="https://github.com/junegunn/fzf#installation" target="_blank" rel="noopener noreffer">here</a>.</p>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-bash" data-lang="bash">git clone --depth <span class="m">1</span> https://github.com/junegunn/fzf.git ~/.fzf
~/.fzf/install
</code></pre></div><p>Reload your shell with the new <code>~/.bashrc</code> settings to make sure FZF is active.</p>
<pre tabindex="0"><code>source ~/.bash_profile
source ~/.bashrc
</code></pre><h2 id="merging-kubeconfig-files">Merging <code>kubeconfig</code> files</h2>
<p>This part is highly opinionated. This what works for me, but I am interested to hear if you know of a better / more efficient way!</p>
<p>All kubeconfig files should be in your <code>~/.kube/</code> directory for this and properly named / sanitized (per above).</p>
<pre tabindex="0"><code>root@rke2-test:~# ls ~/.kube -lah
total 44K
drwxr-xr-x  2 root root 4.0K Dec  9 18:24 .
drwx------ 10 root root 4.0K Dec  8 18:26 ..
-rw-r--r--  1 root root  15K Dec  9 18:24 config
-rw-r--r--  1 root root 3.0K Dec  9 18:20 dev-cluster
-rw-r--r--  1 root root 3.0K Dec  9 18:17 prod-cluster
-rw-r--r--  1 root root 3.0K Dec  9 18:21 qa-cluster
-rw-------  1 root root 3.0K Dec  9 18:13 rke2-homelab
-rw-r--r--  1 root root 3.0K Dec  9 18:21 test-cluster
</code></pre><p>Next, we will use <code>kubectl</code> to merge all of the files we want (in this case, I use every <code>kubeconfig</code> file in the directory, but you can pick and choose) into a single file at <code>~/.kube/config</code>. Since this is the default location where <code>kubectl</code> looks, we don&rsquo;t need to update our <code>KUBECONFIG</code> variable anymore.</p>
<pre tabindex="0"><code>KUBECONFIG=~/.kube/rke2-homelab:~/.kube/prod-cluster:~/.kube/dev-cluster:~/.kube/qa-cluster:~/.kube/test-cluster \
kubectl config view --flatten &gt; tmp &amp;&amp; mv tmp ~/.kube/config
</code></pre><p>Now, if we were to look at our <code>~/.kube/config</code> file, we would see all the separate files merged into one:</p>
<p><strong>(<em>Click the arrow next to YAML to expand</em>)</strong></p>
<div class="highlight"><pre tabindex="0" class="chroma"><code class="language-yaml" data-lang="yaml"><span class="nt">apiVersion</span><span class="p">:</span><span class="w"> </span><span class="l">v1</span><span class="w">
</span><span class="w"></span><span class="nt">clusters</span><span class="p">:</span><span class="w">
</span><span class="w"></span>- <span class="nt">cluster</span><span class="p">:</span><span class="w">
</span><span class="w">    </span><span class="nt">certificate-authority-data</span><span class="p">:</span><span class="w"> </span><span class="l">fake-ca-file</span><span class="w">
</span><span class="w">    </span><span class="nt">server</span><span class="p">:</span><span class="w"> </span><span class="l">https://127.0.0.3:6443</span><span class="w">
</span><span class="w">  </span><span class="nt">name</span><span class="p">:</span><span class="w"> </span><span class="l">dev-cluster</span><span class="w">
</span><span class="w"></span>- <span class="nt">cluster</span><span class="p">:</span><span class="w">
</span><span class="w">    </span><span class="nt">certificate-authority-data</span><span class="p">:</span><span class="w"> </span><span class="l">fake-ca-file</span><span class="w">
</span><span class="w">    </span><span class="nt">server</span><span class="p">:</span><span class="w"> </span><span class="l">https://127.0.0.2:6443</span><span class="w">
</span><span class="w">  </span><span class="nt">name</span><span class="p">:</span><span class="w"> </span><span class="l">prod-cluster</span><span class="w">
</span><span class="w"></span>- <span class="nt">cluster</span><span class="p">:</span><span class="w">
</span><span class="w">    </span><span class="nt">certificate-authority-data</span><span class="p">:</span><span class="w"> </span><span class="l">fake-ca-file</span><span class="w">
</span><span class="w">    </span><span class="nt">server</span><span class="p">:</span><span class="w"> </span><span class="l">https://127.0.0.4:6443</span><span class="w">
</span><span class="w">  </span><span class="nt">name</span><span class="p">:</span><span class="w"> </span><span class="l">qa-cluster</span><span class="w">
</span><span class="w"></span>- <span class="nt">cluster</span><span class="p">:</span><span class="w">
</span><span class="w">    </span><span class="nt">certificate-authority-data</span><span class="p">:</span><span class="w"> </span><span class="l">fake-ca-file</span><span class="w">
</span><span class="w">    </span><span class="nt">server</span><span class="p">:</span><span class="w"> </span><span class="l">https://127.0.0.1:6443</span><span class="w">
</span><span class="w">  </span><span class="nt">name</span><span class="p">:</span><span class="w"> </span><span class="l">rke2-homelab</span><span class="w">
</span><span class="w"></span>- <span class="nt">cluster</span><span class="p">:</span><span class="w">
</span><span class="w">    </span><span class="nt">certificate-authority-data</span><span class="p">:</span><span class="w"> </span><span class="l">fake-ca-file</span><span class="w">
</span><span class="w">    </span><span class="nt">server</span><span class="p">:</span><span class="w"> </span><span class="l">https://127.0.0.5:6443</span><span class="w">
</span><span class="w">  </span><span class="nt">name</span><span class="p">:</span><span class="w"> </span><span class="l">test-cluster</span><span class="w">
</span><span class="w"></span><span class="nt">contexts</span><span class="p">:</span><span class="w">
</span><span class="w"></span>- <span class="nt">context</span><span class="p">:</span><span class="w">
</span><span class="w">    </span><span class="nt">cluster</span><span class="p">:</span><span class="w"> </span><span class="l">dev-cluster</span><span class="w">
</span><span class="w">    </span><span class="nt">user</span><span class="p">:</span><span class="w"> </span><span class="l">dev-cluster</span><span class="w">
</span><span class="w">  </span><span class="nt">name</span><span class="p">:</span><span class="w"> </span><span class="l">dev-cluster</span><span class="w">
</span><span class="w"></span>- <span class="nt">context</span><span class="p">:</span><span class="w">
</span><span class="w">    </span><span class="nt">cluster</span><span class="p">:</span><span class="w"> </span><span class="l">prod-cluster</span><span class="w">
</span><span class="w">    </span><span class="nt">user</span><span class="p">:</span><span class="w"> </span><span class="l">prod-cluster</span><span class="w">
</span><span class="w">  </span><span class="nt">name</span><span class="p">:</span><span class="w"> </span><span class="l">prod-cluster</span><span class="w">
</span><span class="w"></span>- <span class="nt">context</span><span class="p">:</span><span class="w">
</span><span class="w">    </span><span class="nt">cluster</span><span class="p">:</span><span class="w"> </span><span class="l">qa-cluster</span><span class="w">
</span><span class="w">    </span><span class="nt">user</span><span class="p">:</span><span class="w"> </span><span class="l">qa-cluster</span><span class="w">
</span><span class="w">  </span><span class="nt">name</span><span class="p">:</span><span class="w"> </span><span class="l">qa-cluster</span><span class="w">
</span><span class="w"></span>- <span class="nt">context</span><span class="p">:</span><span class="w">
</span><span class="w">    </span><span class="nt">cluster</span><span class="p">:</span><span class="w"> </span><span class="l">rke2-homelab</span><span class="w">
</span><span class="w">    </span><span class="nt">user</span><span class="p">:</span><span class="w"> </span><span class="l">rke2-homelab</span><span class="w">
</span><span class="w">  </span><span class="nt">name</span><span class="p">:</span><span class="w"> </span><span class="l">rke2-homelab</span><span class="w">
</span><span class="w"></span>- <span class="nt">context</span><span class="p">:</span><span class="w">
</span><span class="w">    </span><span class="nt">cluster</span><span class="p">:</span><span class="w"> </span><span class="l">test-cluster</span><span class="w">
</span><span class="w">    </span><span class="nt">user</span><span class="p">:</span><span class="w"> </span><span class="l">test-cluster</span><span class="w">
</span><span class="w">  </span><span class="nt">name</span><span class="p">:</span><span class="w"> </span><span class="l">test-cluster</span><span class="w">
</span><span class="w"></span><span class="nt">current-context</span><span class="p">:</span><span class="w"> </span><span class="l">rke2-homelab</span><span class="w">
</span><span class="w"></span><span class="nt">kind</span><span class="p">:</span><span class="w"> </span><span class="l">Config</span><span class="w">
</span><span class="w"></span><span class="nt">preferences</span><span class="p">:</span><span class="w"> </span>{}<span class="w">
</span><span class="w"></span><span class="nt">users</span><span class="p">:</span><span class="w">
</span><span class="w"></span>- <span class="nt">name</span><span class="p">:</span><span class="w"> </span><span class="l">dev-cluster</span><span class="w">
</span><span class="w">  </span><span class="nt">user</span><span class="p">:</span><span class="w">
</span><span class="w">    </span><span class="nt">client-certificate-data</span><span class="p">:</span><span class="w"> </span><span class="l">fake-cert-file</span><span class="w">
</span><span class="w">    </span><span class="nt">client-key-data</span><span class="p">:</span><span class="w"> </span><span class="l">fake-key-file</span><span class="w">
</span><span class="w"></span>- <span class="nt">name</span><span class="p">:</span><span class="w"> </span><span class="l">prod-cluster</span><span class="w">
</span><span class="w">  </span><span class="nt">user</span><span class="p">:</span><span class="w">
</span><span class="w">    </span><span class="nt">client-certificate-data</span><span class="p">:</span><span class="w"> </span><span class="l">fake-cert-file</span><span class="w">
</span><span class="w">    </span><span class="nt">client-key-data</span><span class="p">:</span><span class="w"> </span><span class="l">fake-key-file</span><span class="w">
</span><span class="w"></span>- <span class="nt">name</span><span class="p">:</span><span class="w"> </span><span class="l">qa-cluster</span><span class="w">
</span><span class="w">  </span><span class="nt">user</span><span class="p">:</span><span class="w">
</span><span class="w">    </span><span class="nt">client-certificate-data</span><span class="p">:</span><span class="w"> </span><span class="l">fake-cert-file</span><span class="w">
</span><span class="w">    </span><span class="nt">client-key-data</span><span class="p">:</span><span class="w"> </span><span class="l">fake-key-file</span><span class="w">
</span><span class="w"></span>- <span class="nt">name</span><span class="p">:</span><span class="w"> </span><span class="l">rke2-homelab</span><span class="w">
</span><span class="w">  </span><span class="nt">user</span><span class="p">:</span><span class="w">
</span><span class="w">    </span><span class="nt">client-certificate-data</span><span class="p">:</span><span class="w"> </span><span class="l">fake-cert-file</span><span class="w">
</span><span class="w">    </span><span class="nt">client-key-data</span><span class="p">:</span><span class="w"> </span><span class="l">fake-key-file</span><span class="w">
</span><span class="w"></span>- <span class="nt">name</span><span class="p">:</span><span class="w"> </span><span class="l">test-cluster</span><span class="w">
</span><span class="w">  </span><span class="nt">user</span><span class="p">:</span><span class="w">
</span><span class="w">    </span><span class="nt">client-certificate-data</span><span class="p">:</span><span class="w"> </span><span class="l">fake-cert-file</span><span class="w">
</span><span class="w">    </span><span class="nt">client-key-data</span><span class="p">:</span><span class="w"> </span><span class="l">fake-key-file</span><span class="w">
</span><span class="w">
</span></code></pre></div><h2 id="using-kubectx-and-kubens">Using <code>kubectx</code> and <code>kubens</code></h2>
<p>Now that we have our files all merged, we can start easily switching contexts and namespaces with <code>kubectx</code> and <code>kubens</code>.</p>
<p>To clarify their purpose:</p>
<ul>
<li>
<p><code>kubectx</code> is used for switching <em>contexts</em>. This allows you to switch to managing different clusters.</p>
</li>
<li>
<p><code>kubens</code> is used for switching <em>namespaces</em> inside of each context. This allows for you to target specific namespaced resources inside an individual cluster.</p>
</li>
<li>
<p>Switch to the <code>prod-cluster</code>:</p>
</li>
</ul>
<pre tabindex="0"><code>kubectl ctx prod-cluster
# Switched to context &quot;prod-cluster&quot;.
</code></pre><ul>
<li>Switch to the <code>devcluster</code>:</li>
</ul>
<pre tabindex="0"><code>kubectl ctx dev-cluster
# Switched to context &quot;dev-cluster&quot;.
</code></pre><ul>
<li>Get a selectable list of clusters you can switch to (if you installed FZF):</li>
</ul>
<pre tabindex="0"><code>kubectl ctx
</code></pre><ul>
<li>Switch to the <code>cattle-system</code> namespace on the <code>prod-cluster</code>:</li>
</ul>
<pre tabindex="0"><code>kubectl ctx prod-cluster
kubectl ns cattle-system
</code></pre><h2 id="closing">Closing</h2>
<p>Hopefully, this blog helps you get a handle on your ever-growing list of Kubernetes clusters that you are managing.</p>
<p>We recommend using <a href="https://rancher.com/products/rancher" target="_blank" rel="noopener noreffer">Rancher</a> if you want a powerful Web UI to manage your clusters, but sometimes the CLI is necessary.</p>
<p>If you have any questions or would like AlphaBravo&rsquo;s assistance in building production-grade Kubernetes clusters,  please reach out to us at <a href="mailto:info@alphabravo.io" rel="">info@alphabravo.io</a>.</p>
<p>Thanks for reading!</p>
<hr>
<p><em>The AB Engineering Team</em></p>
<p><strong>Website:</strong> <a href="https://alphabravo.io" target="_blank" rel="noopener noreffer">https://alphabravo.io</a></p>
<p><strong>Contact Us:</strong> <a href="https://alphabravo.io/contact-us" target="_blank" rel="noopener noreffer">https://alphabravo.io/contact-us</a></p></div><div class="post-footer" id="post-footer">
    <div class="post-info"><div class="post-info-tag"><span><a href="/tags/kubernetes/">kubernetes</a>
                </span><span><a href="/tags/kubeconfig/">kubeconfig</a>
                </span><span><a href="/tags/krew/">krew</a>
                </span></div><div class="post-info-line"><div class="post-info-mod">
                <span>Updated on 2021-12-08</span>
            </div><div class="post-info-mod"></div>
        </div></div><div class="post-nav"><a href="/posts/2021/single-node-rke2-pt2/" class="prev" rel="prev" title="Powerful Single Node RKE2 on Hetzner for CHEAP! (Part 2)"><i class="fas fa-angle-left fa-fw"></i>Previous Post</a>
            <a href="/posts/2021/bulk-delete-clouflare-dns/" class="next" rel="next" title="Bulk Delete Cloudflare DNS Records">Next Post<i class="fas fa-angle-right fa-fw"></i></a></div></div>
</div></article></div>
            </main>
            <footer class="footer"><div class="footer-container"><div class="footer-line">AlphaBravo</div><div class="footer-line" itemscope itemtype="http://schema.org/CreativeWork"><i class="far fa-copyright fa-fw"></i><span itemprop="copyrightYear">2021</span><span class="author" itemprop="copyrightHolder">&nbsp;<a href="/"></a></span></div>
</div>
</footer>
        </div>

        <div id="fixed-buttons"><a href="#" id="back-to-top" class="fixed-button" title="Back to Top">
                <i class="fas fa-chevron-up fa-fw"></i>
            </a></div><link rel="stylesheet" href="/lib/fontawesome-free/all.min.css"><link rel="stylesheet" href="/lib/animate/animate.min.css"><link rel="stylesheet" href="/lib/lightgallery/lightgallery.min.css"><link rel="stylesheet" href="/lib/cookieconsent/cookieconsent.min.css"><script src="/lib/autocomplete/autocomplete.min.js"></script><script src="/lib/lunr/lunr.min.js"></script><script src="/lib/lazysizes/lazysizes.min.js"></script><script src="/lib/typeit/typeit.min.js"></script><script src="/lib/lightgallery/lightgallery.min.js"></script><script src="/lib/lightgallery/lg-thumbnail.min.js"></script><script src="/lib/lightgallery/lg-zoom.min.js"></script><script src="/lib/clipboard/clipboard.min.js"></script><script src="/lib/cookieconsent/cookieconsent.min.js"></script><script>window.config={"code":{"copyTitle":"Copy to clipboard","maxShownLines":20},"comment":{},"cookieconsent":{"content":{"dismiss":"Ok","link":"https://alphabravo.io","message":"We use cookies and open-source, privacy-respecting analytics technologies to improve your browsing experience on our website, to analyze our website traffic, and to understand where our visitors are coming from."},"enable":true,"palette":{"button":{"background":"#f0f0f0"},"popup":{"background":"#1aa3ff"}},"theme":"edgeless"},"data":{"id-1":"Engineering Blog","id-2":"Engineering Blog"},"lightGallery":{"actualSize":false,"exThumbImage":"data-thumbnail","hideBarsDelay":2000,"selector":".lightgallery","speed":400,"thumbContHeight":80,"thumbWidth":80,"thumbnail":true},"search":{"highlightTag":"em","lunrIndexURL":"/index.json","maxResultLength":10,"noResultsFound":"No results found","snippetLength":30,"type":"lunr"},"typeit":{"cursorChar":null,"cursorSpeed":null,"data":{"id-1":["id-1"],"id-2":["id-2"]},"duration":null,"speed":null}};</script><script src="/js/theme.min.js"></script><script data-goatcounter="https://stats.alphabravo.io/count" async src="//stats.alphabravo.io/count.js"></script></body></html>
